' ***********************************************************************
' Decomposition en produits de facteurs premiers par la methode des
' divisions successives
' -----------------------------------------------------------------------
' L'algorithme devrait identifier tous les facteurs <= 10^9
' Les facteurs superieurs a cette valeur pourront ne pas etre identifies,
' auquel cas un point d'interrogation figurera dans le resultat.
' ***********************************************************************

#include "bigint.bi"

' ----------------------------------------------------------------------
' Initialisation de la bibliotheque
' ----------------------------------------------------------------------

const a = 4  ' Indice du nombre a decomposer (on commence a 4 car
             ' l'algorithme utilise les nombres d'indices 0 a 3)
BigInit 5    ' Reserver 5 nombres

' -----------------------------------------------------------------------
' Programme principal
' -----------------------------------------------------------------------

dim n%, nbits%, i%

n = 10
nbits = 48

print "Decomposition en facteurs premiers : Nombres aleatoires de"; nbits; " bits"
print

for i = 1 to n
  SetRnd a, nbits
  print GetStr(a); " = "; BigPrimDec(a)
  print
next i


